'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'II       BASIC++ DEMO ZUM BASIC-COMPUTER UNIT MICRO               II
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'--------------------------------------------------------------------
' Beispiel zum BASIC-COMPUTER    mit dem Programmer/Application-Board
'--------------------------------------------------------------------
' ANWENDUNG:         IIC_BUS - DALLAS 1WIRE BUS CONVERTER (198294)
'                    TEMPERATUR DS1820 AM DALLAS 1WIRE-BUS ABFRAGEN
'                    ANZEIGE AM IIC-BUS LCD
'Dieses Beispiel benutzt das MICROMODUL das die IIC-BUS Ports auf
'Port 5/6 hat. 
'
' ersetzen Sie:  import "....\LIB\MICRO_IIC_GENERICX.BAS"
'          mit:  import "....\LIB\MICRO_IIC_GENERIC.BAS" wenn Sie die
'
' Ports 2/5 benutzen wollen, ndern Sie dann auch die Portzuweisung
' von SDA und SCL in diesem Programm        
'--------------------------------------------------------------------
' Eine kleine DEMO um die TEMPERATUR eines DS1820 am DALLAS
' 1 WIRE BUS abrufragen.
' Das Programm frgt in diesem Beispiel einen DS1820 mit folgender
' Adresse ab: <LSB>16-103-103-158-0-8-0-127<MSB>
' Sie knnen das Programm auf Ihren DS1820 einstellen, wenn Sie die Zeile
' MATCHROM(16,103,103,158,0,8,0,127) auf die Adresse des jeweiligen
' Temperatursensors einstellen, der abgefragt werden soll

' Sie bentigen diese Adresse fr jeden Teilnehmer am Bus. Ein kleines
' Tool, diese auszulesen, finden Sie bei den Beispielen.
'---------------------------------------------------------------------
' Beispielprogramm:
' Das Programm schleift und zeigt die Temperatur am LCD an. Der Abfragezyklus
' wird von der Geschwindigkeit des IIC-BUS bestimmt und betrgt ca.3s
' Der DS1820 kann als wirklicher Zweidraht-Sensor im sog. PARASITE-POWER-MODE
' betrieben werden. Der Vdd Anschluss des Sensors liegt dann an GND und die
' Betriebsspannung wird auf der Datenleitung entnommen. In dieser Betriebsart
' muss die Routine 
'
' #WTC                      'WAIT CONVERTION IN NON-PARASITE POWER MODE
' DS2482WIRE_READBYTE()
' DS2482GET_DATA
' if (DATABYTE and 80h)=0 then goto WTC
'
' durch eine Pause 50 ersetzt werden
' Sie steht in der Function CONVERT() in MICRO_DS1820_GENERIC.BAS

' Sie knnen die Demo benutzen und erweitern ohne die Details im Treiber
' nher zu kennen. Wer sich aber dafr interessiert findet den Treiber
' in der Library und eine Auflistung der Flags im STATUS/CONFIG Register 
' des DS2482
'----------------------------------------------------------------------
' Der 1WIRE-BUS <-> IIC-BUS CONVERTER IST IN DIESM FALL AUF ADRESSE 54,
' ALLE ADRESS-JUMPER SIND ABGEZOGEN.
'-----------------------------------------------------------------------
'
'

'
'------------------------------------------------------------------------


'--------------------------
'------ I/O PORTS ---------
'--------------------------
define LIGHT         port[16]
define SDA           port[5]
define SCL           port[6]
'--------------------------
'---- SYSTEM MEMORY -------
'--------------------------
define TEMPHI       as byte
define TEMPLO       as byte
define HUNDERTER as byte
define ZEHNER as byte
define EINER as byte
define DATABYTE as byte
define COUNTER as byte
const ADDR=01001110b' LCD ADRESSE

import "....\LIB\MICRO_IIC_GENERICX.BAS"
import "....\LIB\MICRO_DS2482_GENERIC.BAS"
import "....\LIB\MICRO_IIC_PCF8574_IO.BAS"
import "....\LIB\MICRO_IIC_LCD_DRIVE.BAS"
import "....\LIB\MICRO_DS1820_GENERIC.BAS"

'----------------------------------------------------
'     SPLIT DATABYTE VALUE INTO DIGITS AND SHOW
'----------------------------------------------------
FUNCTION SHOW_DATA()
HUNDERTER=DATABYTE/100
ZEHNER=(DATABYTE MOD 100)/10
EINER=DATABYTE-10*ZEHNER-100*HUNDERTER
if HUNDERTER=0 then goto NH
LCD_WRITE(ADDR,20h,HUNDERTER+30h)
#NH
if ZEHNER=0 then goto NZ
LCD_WRITE(ADDR,20h,ZEHNER+30h)
#NZ
LCD_WRITE(ADDR,20h,EINER+30h)
END FUNCTION



#INIT
LIGHT=off
'---------- IICBUS INIT ------------------------
SDA=on
SCL=on
'----------------------------------------------
pause 2
LCD_INIT(ADDR)
'-----------------------------------------------------
DS2482RESET()
DS2482WIRERESET()
'-------------------------------------------------------------
'-----            LOOP READING TEMPERATURE                 ---
'-------------------------------------------------------------
#LOOP
pause 5
DS2482SPUON() 
MATCHROM(16,103,103,158,0,8,0,127)
CONVERT()
MATCHROM(16,103,103,158,0,8,0,127)
'--------- GETTING TEMP IN TEMLO/HI --------------------------
DS1820GET_TEMP()
if TEMPHI > 127 then TEMPLO=(not TEMPLO)+1
DATABYTE=TEMPLO/2
LINE1(ADDR,1)
'--------- WRITING "TEMP:" ----------------------------------
LCD_WRITE(ADDR,20h,54h)
LCD_WRITE(ADDR,20h,45h)
LCD_WRITE(ADDR,20h,4Dh)
LCD_WRITE(ADDR,20h,50h)
LCD_WRITE(ADDR,20h,3Ah)
'--------- WRITING THE VALUE --------------------------------
SHOW_DATA()
LCD_WRITE(ADDR,20h,2Eh)
if (TEMPLO and 1) > 0 then 
DATABYTE=35h 
ELSE 
DATABYTE=30h
END IF 
LCD_WRITE(ADDR,20h,DATABYTE)
goto LOOP
attributes
       
ccproject     
ccproject     
  
 
end attributes
