'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'IIIII  BASIC++   DEMO ZUR C-CONTROL UNIT MICRO               IIIIIII
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'--------------------------------------------------------------------
' Beispiel zum BASIC-COMPUTER   und Zubehr
'--------------------------------------------------------------------
' ANWENDUNG:   IIC-BUS LCD (19 83 30)      MIT PCF8574 - ANSTEUERUNG -
'
'--------------------------------------------------------------------
' Das IIC-LCD MODUL beeinhaltet einen PCF8574 zur Ansteuerung des LCD
' Die Untersttzung der Externen Ports durch einen  BASIC-TREIBER machen
' die Ansteuerung recht einfach. Allerdings knnen z.B. Texte an ein
' IIC-BUS LCD nicht so komfortabel gesendet werden, wie das beim LCD
' an Byteport 2 der UNIT M 2.0/M 1.2 der Fall ist.
'--------------------------------------------------------------------
' Der IIC-Bus liegt an PORT 2 (SDA) und PORT 5 (SCL)
'
' Beschreibung:
' Der PCF8574 hat eine whlbare 3-Bit Adresse. In unserem Beispiel gehen wir
' davon aus, dass alle Bits der Adresse HI sind
'
' const ADDR=01001110b LCD ADRESSE legt die Adresse fr dieses Beispiel fest.
'
' Das Programm zeigt die Uhrzeit an
' Das Programm importiert eine ASCII Tabelle, damit Sie einfach einen Buchstaben
' an das Unterprogramm bergeben knnen.
' Der eigentliche Treiber wird ebenfalls importiert. Es werden die Adresse,
' das Kommando 20h und der Buchstabe an LCDWRITE bergeben.
'
' LCD_WRITE(ADDR,20h,U)
'
'-----------------------------------------------------------------------
' Achtung, ganz wichtig:
' Die Ports mssen als Ausgang initialisiert werden bevor der IIC-Bus
' benutzt wird: SDA=on:SCL=on
'-----------------------------------------------------------------------
'Hier sehen Sie, welche PCF 8574 Ports dem LCD zugeordnet sind:
'Port 0  LCD DB4
'Port 1  LCD DB5
'Port 2  LCD DB6
'Port 3  LCD DB7
'Port 4  LCD R/W
'Port 5  LCD RS
'Port 6  LCD EN
'-------------------------------------------------------------------
'--------------------------
'------ I/O PORTS ---------
'--------------------------
define BEEPER   port[6]
'--- IIC INTERFACE  -------
define SDA      port[2]
define SCL      port[5]
'--------------------------
'------ SYSTEM MEMORY -----
'--------------------------
define OLD_SEC as byte
define DATABYTE as byte
define ZEHNER      as byte
define EINER       as byte

const ADDR=01001110b' LCD ADRESSE


import "....\LIB\ASCII_TABLE.BAS"
import "....\LIB\MICRO_IIC_GENERIC.BAS"
import "....\LIB\MICRO_IIC_PCF8574_IO.BAS"
import "....\LIB\MICRO_IIC_LCD_DRIVE.BAS"

'----------------------------------------------------
'          SPLIT VALUE INTO DIGITS
'----------------------------------------------------
FUNCTION SPLIT_DIGITS()
ZEHNER=DATABYTE/10
EINER=DATABYTE-ZEHNER*10+30h
ZEHNER=ZEHNER+30h 
END FUNCTION

'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'II   PCF 8574 PORTERWEITERUNG FR LCD        II
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'---------- IICBUS INIT ------------------------
SDA=on
SCL=on
'----------------------------------------------
pause 2
LCD_INIT(ADDR)
'--------------------------------------------------
'                 MAKING A CLOCK                   -
'--------------------------------------------------
#WAITSEC
'------ WARTEN AUF SEKUNDENWECHSEL ----------------
if OLD_SEC = second then goto WAITSEC
'---------- ZEIT ANZEIGEN -------------------------
OLD_SEC=second

LINE1(ADDR,4)
'--------------------------------------------------
DATABYTE=HOUR
SPLIT_DIGITS()
LCD_WRITE(ADDR,20h,ZEHNER)
LCD_WRITE(ADDR,20h,EINER)
LCD_WRITE(ADDR,20h,3Ah)
'--------------------------------------------------
DATABYTE=MINUTE
SPLIT_DIGITS()
LCD_WRITE(ADDR,20h,ZEHNER)
LCD_WRITE(ADDR,20h,EINER)
LCD_WRITE(ADDR,20h,3Ah)
'--------------------------------------------------
DATABYTE=SECOND
SPLIT_DIGITS()
LCD_WRITE(ADDR,20h,ZEHNER)
LCD_WRITE(ADDR,20h,EINER)
goto WAITSEC

'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII







attributes
ccproject                
ccproject               
           
         
         
        
      
     
    
   
  
 
end attributes
