'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'IIIIIII     BASIC++  DEMO ZUR C-CONTROL MICRO             IIIIIIIIIIII
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
' Beispiel zum BASIC-COMPUTER   und Zubehr
'
' ANWENDUNG:   IIC-BUS TASTATUR (19 83 56) MIT PCF8574 - DECODIERUNG -
'              IIC-BUS LCD (19 83 30) MIT PCF8574      - ANSTEUERUNG -
'-----------------------------------------------------------------------
' Sie sehen hier die Anwendung der C-Control MICRO mit einer PCF8574
' Porterweiterung fr eine Tastatut und ein LCD.
' Der PCF8574 befindet sich auf dem IIC-BUS TASTATUR MODUL
' und auf dem LCD Modul. Es befinden sich beide Treiber auf in diesem 
' Programm. Der Treiber fr das LCD ist der gleiche wie in den Beispielen 
' zum IIC-BUS LCD Modul
'
' Der Treiber fr den TASTATURDECODER und die Ansteuerung des LCD hat zusammen
' etwa 600 Bytes, sodass fr das Anwenderpogramm noch gengend Platz ist.
'-----------------------------------------------------------------------
' Der PCF8574 wird ber einen IIC-Bus angesteuert der hier als BASIC
' -Treiber ausgefhrt ist. Der IIC-Bus bentigt zwei Ports stellt aber
' selbst 8 Ports zur Verfgung.
' Die Ports fr den IIC-Bus sind hier PORT2=SDA und PORT5=SCL
' Sie knnen natrlich mehrere PCF5478 an der MICRO betreiben.
' Dazu mssen die Bausteine natrlich unterschiedliche Adressen haben.
'-----------------------------------------------------------------------
' In diesem Beispiel wird ein PCF8574 verwendet um eine 4x4 Matrix-Tastatur
' zu decodieren. Der Aufruf von GET_MATRIX_KEY mit der Adresse als Parameter,
' liefert in der globalen Variablen KEY den Tastencode der Matrix-Tastatur zurck
' Das Programm zeigt am LCD den Tastencode 0 bis 9 fr die jeweiligen Ziffern
' und die Codes 11 bis 16 fr Funktionstasten A bis F.
' Beachten Sie dass die beiden PCF8574 jeweils auf unterschiedlichen Adressen
' laufen mssen.
'
' In diesem Beispiel sind folgende Adressen vergeben:
'
'- PCF8574 TASTATUR DEVICE WRITE ADDRESS --
'  const KADDR = 01001100b
'------ PCF8574 LCD DEVICE WRITE ADDRESS -------
'  const LADDR = 01001110b

'--------------------------------------------------------------------------
' Sie knnen SDA und SCL natrlich auch auf andere Digitalports legen,
' wenn Ihre Anwendung das erfordert.
'--------------------------------------------------------------------------
'--------------------------
'------ I/O PORTS ---------
'--------------------------
'--- IIC INTERFACE  -------
define SDA      port[2]
define SCL      port[5]
'--------------------------
'------ SYSTEM MEMORY -----
'--------------------------
'--- IIC INTERFACE  -------
define DATABYTE as byte

'---------------------------
define TAUSENDER   as byte
define HUNDERTER   as byte
define ZEHNER      as byte
define EINER       as byte
define KEY         as byte
'-------------------------



'- PCF8574 TASTATUR DEVICE WRITE ADDRESS --
const KADDR = 01001100b
'------ PCF8574 LCD DEVICE WRITE ADDRESS -------
const LADDR = 01001110b

import "....\LIB\ASCII_TABLE.BAS"
import "....\LIB\MICRO_IIC_GENERIC.BAS"
import "....\LIB\MICRO_IIC_PCF8574_IO.BAS"
import "....\LIB\MICRO_IIC_LCD_DRIVE.BAS"
import "....\LIB\MICRO_IIC_KEYBOARD.BAS"

'----------------------------------------------------
'          SPLIT VALUE INTO DIGITS
'----------------------------------------------------
FUNCTION SPLIT_DIGITS(VALUE as byte)
HUNDERTER=VALUE/100
ZEHNER=(VALUE-(HUNDERTER*100))/10
EINER=VALUE-HUNDERTER*100-ZEHNER*10 
END FUNCTION
'----------------------------------------------------



'---------- IICBUS INIT ------------------
SDA=on
SCL=on
pause 1

'----------- LCD INIT --------------------
lcd_init(LADDR)
pause 2
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'II   MATRIX KEY-DECODE AND DISPLAY     II
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
#LOOP
'----- WRITE CHARACTERS LINE 1 ---------------
LINE1(LADDR,4)
LCD_WRITE(LADDR,20h,K)
LCD_WRITE(LADDR,20h,E)
LCD_WRITE(LADDR,20h,Y)
LCD_WRITE(LADDR,20h,BLANK)
GET_MATRIX_KEY(KADDR)
SPLIT_DIGITS(KEY)
LCD_WRITE(LADDR,20h,HUNDERTER+30h)
LCD_WRITE(LADDR,20h,ZEHNER+30h)
LCD_WRITE(LADDR,20h,EINER+30h)
goto LOOP

attributes
ccproject                 
ccproject               
             
     
   
end attributes
