'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'III  BASIC++ DEMO ZUR MICRO - SYSTEMERWEITERUNG  EXTENSION 1   IIIII
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
' Beispiel zum BASIC-COMPUTER   und Zubehr
'
' ANWENDUNG:   MICROMODUL  (19 83 81) ANSTEURUNG LCD AM APPLICATION BOARD
'              DCF-SYNCHRONISIERUNG DER UHR
'-----------------------------------------------------------------------
' Sie sehen hier die Anwendung der C-Control MICRO mit einer PCF8574
' Porterweiterung. Der PCF8574 befindet sich auf dem IIC-BUS LCD MODUL
' bzw. auf dem MICROMODUL und steuert in diesem Fall das LCD des
' Application Board an.
' Der IIC-BUS liegt am MICROMODUL an den Ports 5 und 6. 
' Deshalb wird hier, abweichend von anderen Beispielen zun IIC-BUS
' der BASIC-Treiber "MICRO_IIC_GENERICX.BAS" geladen.
' Dieses Beispiel spricht den PCF8574 auf dem MICROMODUL auf der
' Adresse 01001110 an, alle Adress-Jumper auf dem MICROMODUL mssen daher
' abgezogen sein
'--------------------------------------------------------------------
' Diese Demo ladet die BASIC-SYSTEMERWEITERUNG "PAGE0_EXT1.S19"
' und zeigt wie die RTC der MICRO mit einer DCF-Uhr synchronisiert wird.
' Fr den Betrieb muss das DCF77 Empfangsmodul am Application-Board 2.0
' gesteckt sein. Der geladene Treiber erwartet das DCF-Signal an Port 4
' Wenn Sie das DCF77 Empfangsmodul am Application-Board gesteck haben, mssen
' Sie PORT4 der MICRO mit FREQ1 auf der Busleiste des MICRO-MODULS verbinden.
' Ausserdem ist es erforderlich den Port mit einem PULLUP Widerstand nach HI
' zu ziehen.
' Wenn der BEEPER aktiviert werden soll mssen Sie zustzlich Port1 mit dem
' Anschluss BEEP am MICROMODUL verbinden.
' Die Ausgabe erfolgt auf das LCD am Application-Board 2.0
'
' Der Aufruf SYS  DCFSYNC startet die Synchronisation, die nach ca. 2 Minuten
' abgeschlossen ist.
' Mit dieser Erweiterung wird auch der Befehl RXD freigeschaltet der anzeigt, ob
' die Uhrzeit Synchronisiert ist.
' Verwendet wird er z.B. so:
'
' if RXD then goto SYNC
' if NOT RXD then goto UNSYNC

' In unserem Beispiel wird der BEEPER aktiviert wenn die Uhrzeit synchronisiert ist.
' Nach der Synchronisation luft die Uhrzeit mit RTC-Genauigkeit weiter, sodass
' Sie SYS DCFSYNC entsprechend den Anforderungen an die Genauigkeit der RTC hufiger
' aufrufen mssen.
'------------------------------------------------------------------------
'  !! Die Synchronisation beeinhaltet keine Korrektur von bertragungsfehlern !!
' Wenn Sie die Uhreit hundertprozentig sicher anzeigen zu wollen, mssen Sie
' fr eine Verifizierung mehrer Rahmen selbst Sorge tragen.
' In diesem Beispiel wird die empfangene Zeitinformation auf einfache Plausibilitt
' geprft, was in den meisten Fllen vllig ausreichend ist.
'------------------------------------------------------------------------
' Weitere Details zu dieser Systemerweiterung und DCF-Synchronisierung finden Sie
' im Beispiel DCF_SYNC.BAS
'-----------------------------------------------------------------------
' SIE DRFEN DIESEN TREIBER NUR LADEN, WENN DIE PAGE0/1 NICHT VON ANDEREN
' TREIBERN/SYSTEMERWEITERUNGEN, DIE SIE BENTIGEN, BELEGT IST !
' Der Treiber ist nicht fr die MICRO mit der OS-Version 2.00 geeignet
'---------------------------------------------------------------------

'-----------------------------------------------------------------------
' Achtung, ganz wichtig:
' Die Ports mssen als Ausgang initialisiert werden bevor der IIC-Bus
' benutzt wird: SDA=on:SCL=on
'-----------------------------------------------------------------------
'Hier sehen Sie, welche PCF 8574 Ports dem LCD zugeordnet sind:
'Port 0  LCD DB4
'Port 1  LCD DB5
'Port 2  LCD DB6
'Port 3  LCD DB7
'Port 4  LCD R/W
'Port 5  LCD RS
'Port 6  LCD EN
'-------------------------------------------------------------------
'--------------------------
'------ I/O PORTS ---------
'--------------------------
define DCFIN    port[4]
define BEEPER   port[1]
'--- IIC INTERFACE  -------
define SDA      port[5]
define SCL      port[6]
'--------------------------
'------ SYSTEM MEMORY -----
'--------------------------
define OLD_SEC as byte
define DATABYTE as byte
define ZEHNER      as byte
define EINER       as byte

const DCFSYNC= FD09h
const ADDR=01001110b' LCD ADRESSE


import "....\LIB\ASCII_TABLE.BAS"
import "....\LIB\MICRO_IIC_GENERICX.BAS"
import "....\LIB\MICRO_IIC_PCF8574_IO.BAS"
import "....\LIB\MICRO_IIC_LCD_DRIVE.BAS"

'-------------------------------------------------
'--------- VERIFY TIME INFORMATION ---------------
'-------------------------------------------------
FUNCTION VERIFY()
if (HOUR>24)or (MINUTE >59) then goto RESYNC
beep 100,5,BEEPER
EXIT FUNCTION
#RESYNC
HOUR=0
MINUTE=0
SECOND=0
SYS DCFSYNC
END FUNCTION
'----------------------------------------------------
'          SPLIT VALUE INTO DIGITS
'----------------------------------------------------
FUNCTION SPLIT_DIGITS()
ZEHNER=DATABYTE/10
EINER=DATABYTE-ZEHNER*10+30h
ZEHNER=ZEHNER+30h 
END FUNCTION



'HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH
SYS DCFSYNC
'---------- IICBUS INIT ------------------------
SDA=on
SCL=on
'----------------------------------------------
pause 2
LCD_INIT(ADDR)
'--------------------------------------------------
'       MAKING A RADIO CONTROLLED CLOCK           -
'--------------------------------------------------
#WAITSEC
'------ WARTEN AUF SEKUNDENWECHSEL ----------------
if OLD_SEC = second then goto WAITSEC
'---------- ZEIT ANZEIGEN -------------------------
OLD_SEC=second
if RXD then VERIFY()

LINE1(ADDR,4)
'--------------------------------------------------
DATABYTE=HOUR
SPLIT_DIGITS()
LCD_WRITE(ADDR,20h,ZEHNER)
LCD_WRITE(ADDR,20h,EINER)
LCD_WRITE(ADDR,20h,3Ah)
'--------------------------------------------------
DATABYTE=MINUTE
SPLIT_DIGITS()
LCD_WRITE(ADDR,20h,ZEHNER)
LCD_WRITE(ADDR,20h,EINER)
LCD_WRITE(ADDR,20h,3Ah)
'--------------------------------------------------
DATABYTE=SECOND
SPLIT_DIGITS()
LCD_WRITE(ADDR,20h,ZEHNER)
LCD_WRITE(ADDR,20h,EINER)
goto WAITSEC

'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII

syscode "page0_ext1.s19"






attributes
ccproject                   
ccproject                  
              
            
            
           
         
        
       
      
     
    
   
  
 
end attributes
