'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'IIII  BASIC++   DEMO ZUM BASIC-COMPUTER UNIT MICRO             IIIII
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'--------------------------------------------------------------------
' Beispiel zum BASIC-COMPUTER   und Zubehr
'--------------------------------------------------------------------
' ANWENDUNG:   MICROMODUL  (19 83 81) ANSTEURUNG LCD AM APPLICATION BOARD
'              ZUBEHR IR SENDE/EMPFANGSMODUL 198860 oder TSOP1836
'              SYSTEMTREIBER FR RC5 DECODIEREUNG
'               
'--------------------------------------------------------------------
' Dieses Beispiel zeigt die Vorgehensweise fr die Benutzung des IR
' Treibers (RC5 codiert) im Betriebssystem, zusammen mit
' dem als Zubehr erhltlichen IR SENDE/EMPFANGSMODUL oder mit einem
' IR Empfngerbaustein TSOP 1838
' Das IR SENDE/EMPFANGSMODUL 198860 knnen Sie als Empfnger verwenden .
' Dazu muss der PORT4 der UNIT mit PORT2 auf der BUSLEISTE des Application
' Boards verbunden sein und das IR SENDE/EMPFANGSMODUL muss auf dem
' Application-Board gesteckt sein
' 
' Der IIC-BUS liegt am MICROMODUL an den Ports 5 und 6. 
' Deshalb wird hier, abweichend von anderen Beispielen zun IIC-BUS
' der BASIC-Treiber "MICRO_IIC_GENERICX.BAS" geladen.
' Dieses Beispiel spricht den PCF8574 auf dem MICROMODUL auf der
' Adresse 01001110 an, alle Adress-Jumper auf dem MICROMODUL mssen daher
' abgezogen sein
'--------------------------------------------------------------------
' Das RC5 Format wird von den meisten Gerten der Unterhaltungsindustrie
' verwendetund ermglicht es Ihnen diese Gerte mit dem BASIC-Computer
' zu steuern. Das RC5 Format besteht aus einer Gerteadresse und einem
' Kommando. 
'
' RC5 FORMAT:
'    13-12-11-10-09-08-07-06-05-04-03-02-01-00   DATA BIT
'     S  S  T a4 a3 a2 a1 a0 c5 c4 c3 c2 c1 c0   RC5
'
' Der Teiber untersttzt den IR Datensender allerdings nicht, sodass
' nur Empfang mglich ist.

' Beschreibung:
' Das Programm wartet auf einen empfangenen IR-Code.
' Wird ein Code empfangen, so wird der Empfangene Code am LCD angezeigt.
' Es wurde nichts empfangen, oder der Empfangsbuffer ist bereits geleert,
' wenn der Inhalt von ADDR und CMD jeweils 0 ist.
'-----------------------------------------------------------------------
' SIE DRFEN DIESEN TREIBER NUR LADEN, WENN DIE PAGE0/1 NICHT VON ANDEREN
' TREIBERN/SYSTEMERWEITERUNGEN, DIE SIE BENTIGEN, BELEGT IST !
' Der Treiber ist nicht fr die MICRO mit der OS-Version 2.00 geeignet
'---------------------------------------------------------------------



'--------------------------
'------ I/O PORTS ---------
'--------------------------
'--- IIC INTERFACE  -------
define SDA      port[5]
define SCL      port[6]
'---- IR RECCEIER ---------
define IRIN      port[4]
define COMMAND   byte[1]
define ADDRESS   byte[2]
define DATABYTE as byte
define ZEHNER      as byte
define EINER       as byte
'--------------------------
'------ SYSTEM MEMORY -----
'--------------------------

const ADDR=01001110b' LCD ADRESSE


import "....\LIB\ASCII_TABLE.BAS"
import "....\LIB\MICRO_IIC_GENERICX.BAS"
import "....\LIB\MICRO_IIC_PCF8574_IO.BAS"
import "....\LIB\MICRO_IIC_LCD_DRIVE.BAS"

'----------------------------------------------------
'          SPLIT VALUE INTO DIGITS
'----------------------------------------------------
FUNCTION SPLIT_DIGITS()
ZEHNER=DATABYTE/10
EINER=DATABYTE-ZEHNER*10+30h
ZEHNER=ZEHNER+30h 
END FUNCTION

'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'II   PCF 8574 PORTERWEITERUNG FR LCD        II
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'---------- IICBUS INIT ------------------------
SDA=on
SCL=on
'------------   LCD INIT -----------------------
pause 2
LCD_INIT(ADDR)
'--------- IR BACKGROUND RECEIVING INIT --------
SYS FD06h 
ADDRESS=0
COMMAND=0
'------- WRITE CHARACTERS LINE 1 ---------------
LINE1(ADDR,1)
LCD_WRITE(ADDR,20h,W)
LCD_WRITE(ADDR,20h,A)
LCD_WRITE(ADDR,20h,I)
LCD_WRITE(ADDR,20h,T)
LCD_WRITE(ADDR,20h,I)
LCD_WRITE(ADDR,20h,N)
LCD_WRITE(ADDR,20h,G)
LCD_WRITE(ADDR,20h,DOT)
LCD_WRITE(ADDR,20h,DOT)
LCD_WRITE(ADDR,20h,DOT)

#LOOP
if (ADDRESS or COMMAND)=0 then goto LOOP
LINE1(ADDR,1)
LCD_WRITE(ADDR,20h,A)
LCD_WRITE(ADDR,20h,D)
LCD_WRITE(ADDR,20h,R)
LCD_WRITE(ADDR,20h,BLANK)
DATABYTE=ADDRESS
SPLIT_DIGITS()
LCD_WRITE(ADDR,20h,ZEHNER)
LCD_WRITE(ADDR,20h,EINER)

LINE2(ADDR,1)
LCD_WRITE(ADDR,20h,C)
LCD_WRITE(ADDR,20h,M)
LCD_WRITE(ADDR,20h,D)
LCD_WRITE(ADDR,20h,BLANK)
DATABYTE=COMMAND
SPLIT_DIGITS()
LCD_WRITE(ADDR,20h,ZEHNER)
LCD_WRITE(ADDR,20h,EINER)
ADDRESS=0
COMMAND=0
pause 10
LCD_CLR(ADDR)

goto LOOP
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII

SYSCODE "RC5_P0.s19"






attributes
ccproject                  
ccproject                 
             
           
           
          
        
       
      
     
       
   
  
    
end attributes
