'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'IIII          BASIC++ DEMO ZUM C-CONTROL MICRO             IIIIIIIIIII
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
' CONRAD ELECRONIC 9.03 (by DIE HARD)
'
'----------------------------------------------------------------------
' THEMA: ECHTZEITUHR (RTC)
'----------------------------------------------------------------------
' Beispiel zur C-Control MICRO mit dem Programmer/Application-Board (P/A-BOARD)
' Die C-CONTROL MICRO hat eine eingebaute Echtzeituhr die wir hier als Zeitschaltuhr
' fr ein Treppenlicht benuzen
'
' In diesem Beispiel gelten folgende Vorgaben fr das Treppenlicht:
' - Das Treppenlicht wird mit PORT 5 (LED) geschaltet
' - Der Taster ist an PORT 3 angeschlossen.
' - Whrend der Tageszeit brennt es 5 Sekunden, nachts aber 10 Sekunden.
' - Es ist retriggerbar (wenn der Taster vor Ablauf der Zeit gedrckt wird,
'   beginnt die Zeitzhlung neu)
'
' Im Betriebssystem der MICRO ist der Wochentag oder das Datum nicht Bestandteil
' der RTC lassen sich aber leicht erzeugen.
' Mit zwei Variablen wird z.B. der Wochentag erzeugt und das Beispiel kann auf eine
' weitere Funktion ausgedehnt werden (z.B. dass es Montags gar kein Licht gibt)
'
' Das Unterprogramm muss mindestens einmal pro Stunde aufgerufen werden.
' Beachten Sie, dass Sie keine SYSTEMVARIABLEN verwenden drfen welche die MICRO
' nicht kennt also z.B. DOW
' 
'
' Stecken Sie bitte die Jumper JP2 und JP1 (auf Position 1-2)damit die Demo korrekt
' funktioniert.
'-----------------------------------------------------------------------
'ACHTUNG:
' Systembedingt ist die Genauigkeit der RTC sehr schlecht. Sie haben aber als Benutzer
' die Mglichkeit die Eigenschaften durch eine Calibrierung zu verbessern.
' Das Beispiel TOOL_CLOCK_CALIBRATE.BAS gibt Ihnen weitere Hinweise zu diesem Thema.
' Die RTC lsst sich ausserdem mit einem DCF77 Emfnger und einer BASIC
' Systemerweiterung synchronisieren.Sehen Sie dazu bitte in den Ordner "BASIC_ERWEITERUNGEN"
'-----------------------------------------------------------------------

'--------------------------
'------ I/O PORTS ---------
'--------------------------
define TASTER   port[3]
define LED      port[5]
'--------------------------
'---- SYSTEM MEMORY -------
'--------------------------
define SECOND_COUNTER  byte[1]
define OLD_SECOND      byte[2]
define RUNNING_TIME    byte[3]

'-------------- INITIALIZE ------------------------
LED=off
HOUR=17
MINUTE=59

'--------------------------------------------------
'          USING THE REALTIME CLOCK                -
'--------------------------------------------------
#BUTTON_WAIT
'--------- WAIT FOR BUTTON PRESSED ---------------
if TASTER=on then goto BUTTON_WAIT

'-------------------------------------------------
'---------BUTTON IS PRESSED NOW ------------------
'-------------------------------------------------
RUNNING_TIME=5                   ' 5s tags
if HOUR>=18 then RUNNING_TIME=10 '10s nachts
LED=on
SECOND_COUNTER=0

'-------------------------------------------------
'------------- LIGHT IS ACTIVATET ----------------
'-------------------------------------------------
#SECONDS_TICKING
'--------- CHECK IF RETRIGGERED ------------------
if TASTER=off then SECOND_COUNTER=0
if OLD_SECOND=SECOND then goto SECONDS_TICKING
'---------- COUNTING SECONDS --------------------
OLD_SECOND=SECOND
SECOND_COUNTER=SECOND_COUNTER+1
'--------- CHECK IF TIME ELAPSED -----------------
if SECOND_COUNTER=RUNNING_TIME then goto TIME_ELAPSED
'----------       LOOP         -------------------
goto SECONDS_TICKING

'------------------------------------------------
'----------- SWITCH LIGHT OFF -------------------
'------------------------------------------------
#TIME_ELAPSED
LED=off
goto BUTTON_WAIT





attributes
    
end attributes
